'+--------------------------------------------------------------------------+
'|                                Carousel                                  |
'|                                                                          |
'|                      Skin Engine for VISTA and XP                        |
'|           with full crystal and blur effect in composited mode           |
'|                                                                          |
'|                Example of what is going on behind the hood.              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2007                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-04-2007 (MM-DD-YYYY)            |
'|                        Last revised : 10-17-2007 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "Crystal.exe"

'//DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO

#INCLUDE "ZSKIN.INC"
'#INCLUDE "ZCOLORPICK.INC"

TYPE POINTS
  x AS INTEGER
  y AS INTEGER
END TYPE

#INCLUDE "GDIMAGE.INC"
'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------

TYPE SpriteDataStruct
    ImageName AS ASCIIZ * 128
    hBitmap   AS LONG
    ID        AS LONG
    xPos      AS LONG
    yPos      AS LONG
    nWidth    AS LONG
    nHeight   AS LONG
    rAngle    AS SINGLE
END TYPE

%XMIN_SIZE = 801
%YMIN_SIZE = 480

%ID_CTRL                = -1
%ID_OBJECT_TEXT         = -2

%ID_BTN_PLAY            = 1
%ID_BTN_PAUSE           = 2
%ID_LEFTBUTTON          = 3
%ID_RIGHTBUTTON         = 4
%ID_BTN_RESET           = 5
%ID_LABEL_SPEED         = 6
%ID_TRACK_SPEED         = 7
%ID_LABEL_FOCAL         = 8
%ID_TRACK_FOCAL         = 9
%ID_MARQUEE             = 10
%ID_OPACITY             = 11
%ID_BACKGROUND          = 12
%ID_USE3D               = 13
%ID_SELFROTATION        = 14
%ID_TRACK_Y             = 15
%ID_LABEL_Y             = 16

%ID_FRAMEBUTTON         = 17
%ID_GLASS_OPACITY_LABEL = 18
%ID_TRACK_OPACITY       = 19
%ID_AEROCRYSTAL         = 20
%ID_AEROBLUR            = 21
%ID_AERODISABLE         = 22

%AERO_TIMER             = 1
%CAROUSEL_TIMER         = 2
%BLINK_TIMER            = 3

%ID_MAX_SPRITE          = 12

%Speed_default = 4
%Focus_default = 15000
%Y_default     = 50

GLOBAL gMoveToLeft, gAnimate, gnBoundWidth, gnBoundHeight, gBlinkCount AS LONG
GLOBAL gSpriteData() AS SpriteDataStruct

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZCAROUSEL"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zInstance
       wc.hIcon         = %NULL ' LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL ' Don't paint the class window background
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
'
     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS

       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "Carousel"
       hMain = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                             zClass, _               ' Class Name
                             (MyTitle$), _           ' Window Title
                             dwStyle, _              ' Defined Window Style
                             x, y, _                 ' Window Position
                             rc.nRight - rc.nLeft, _ ' Calculate Window Width
                             rc.nBottom - rc.nTop, _ ' Calculate Window Height
                             %NULL, _                ' No Parent Window
                             %NULL, _                ' No Menu
                             wc.hInstance, _         ' Instance
                             BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(hMain, "Crystal.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls(hMain)

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(5) ' 5 = UseStep for composited window on XP


'         // To let the user know that he should click this button to play the carousel
          CALL SetFocus(GetDlgItem(hMain, %ID_BTN_Play))
          CALL SetTimer(hMain, %BLINK_TIMER, 333, %NULL)
         
          CALL SetTimer(hMain, %CAROUSEL_TIMER, 0, %NULL)
          'IF SK_AEROEMULATE() THEN CALL SetTimer(hMain, ", SK_AEROTIMERDELAY(), %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(hMain, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND
          'IF SK_AEROEMULATE() THEN CALL KillTimer(hMain, %AERO_TIMER)
          CALL KillTimer(hMain, %CAROUSEL_TIMER)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Add child controls to main window
SUB AddChildControls(BYVAL hMain AS LONG)

    LOCAL hBut, imgW, imgH AS LONG
    LOCAL Alpha, Red, Green, Blue AS BYTE

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

'   Create the GDImage graphic control
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = 0'%WS_EX_STATICEDGE
    gCtrl& = CreateWindowEx(StyleEx&, _
                           "ZIMAGECTRL", _            ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           17, _                      ' initial x position
                           42, _                      ' initial y position
                           588, _                     ' Calculate Window Width
                           420, _                     ' Calculate Window Height
                           hMain, _                   ' parent window handle
                           %ID_CTRL, _                ' ControlID
                           zInstance(), _             ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   In case of image background stretch it to match the size of the graphic control
'   or center it when smaller than the view port.
    CALL ZI_SetProperty(gCtrl&, %ZI_FitToWindow, %ZI_QualityDefault)
'   Resize the control to macth the whole size of the parent window
    CALL zSetAnchorMode(gCtrl&, %ANCHOR_HEIGHT_WIDTH)

'   ___________________

    hBut = zFrameButton(hMain, (SK_FOLDER() + "Aero.png"), "", 619, 47, 158, 333, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_BOTTOM)
'   ___________________

    hBut = zStaticLabel(hMain, "Speed", 628, 55, 140, 15, %ID_LABEL_SPEED, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    hBut = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 628, 69, 140, 14, %ID_TRACK_SPEED, 1, 30, 4, SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Change the speed rotation")

    hBut = zStaticLabel(hMain, "Focal length", 628, 87, 140, 15, %ID_LABEL_SPEED, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    hBut = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 628, 101, 140, 14, %ID_TRACK_FOCAL, 1, 30000, 15000, SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Adjust the focal length")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Marquee text", 627, 120, 110, 22, %ID_MARQUEE, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Show/Hide the marquee text effect")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Variable opacity", 627, 141, 110, 22, %ID_OPACITY, SK_BTNTEXTCOLOR(), 0)
    CALL zSetCheckButtonStatus(hBut, %TRUE)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Enable/disable variable opacity")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Wallpaper", 627, 162, 110, 22, %ID_BACKGROUND, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Hide or show image background")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Use 3D depth", 627, 183, 110, 22, %ID_USE3D, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Enable or disable the 3D depth")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Self rotation", 627, 204, 110, 22, %ID_SELFROTATION, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Enable or disable self rotation")

    hBut = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 755, 126, 16, 80, %ID_TRACK_Y, 100, -100, 50, SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Change location along Y axis")
    hBut = zStaticLabel(hMain, "Y", 758, 208, 16, 15, %ID_LABEL_Y, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)

    hBut = zPushButton(hMain, (SK_FOLDER() + "BTN_Push.png"), "Reset", 626, 229, 144, 28, %ID_BTN_RESET, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Restaure to initial state")
'   ___________________

IF Vista() THEN
    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Crystal mode", 627, 271, 130, 22, %ID_AEROCRYSTAL, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Switch Skin display to CRYSTAL mode")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Blur mode", 627, 292, 130, 22, %ID_AEROBLUR, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Switch Skin display to BLUR mode")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Standard mode", 627, 313, 130, 22, %ID_AERODISABLE, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Switch back to standard display mode")

    hBut = zStaticLabel(hMain, "Client zone opacity", 628, 342, 140, 15, %ID_GLASS_OPACITY_LABEL, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)

    CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
    hBut = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 628, 357, 140, 14, %ID_TRACK_OPACITY, 0, 255, Alpha, SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "To change client opacity (AERO must be On)")
END IF

    hBut = zButImage(hMain, (SK_FOLDER() + "BTN_Pause.png"), 673, 403, %ID_BTN_PAUSE, 0)
    CALL zGetImageSize(zGetButImageProperty(hBut), imgW, imgH): imgW = imgW \ 5
    CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_BOTTOM)
    CALL zSetAnchorMode(hBut, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Pause carousel animation")

    hBut = zButImage(hMain, (SK_FOLDER() + "BTN_Play.png"), 673, 403, %ID_BTN_PLAY, 0)
    CALL zGetImageSize(zGetButImageProperty(hBut), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hBut, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Play carousel animation")

    hBut = zButImage(hMain, (SK_FOLDER() + "BTN_Left.png"), 618, 415, %ID_LEFTBUTTON, 0)
    CALL zGetImageSize(zGetButImageProperty(hBut), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hBut, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Play carousel in clock wise mode")

    hBut = zButImage(hMain, (SK_FOLDER() + "BTN_Right.png"), 722, 415, %ID_RIGHTBUTTON, 0)
    CALL zGetImageSize(zGetButImageProperty(hBut), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hBut, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Play carousel in counter clock mode")

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(hMain, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(hMain, %ID_LED), %HWND_TOP)

'   // Use the Skin's name for caption
    CALL zSetCTLText(hMain, (PARSE$(SK_AUTHOR(), $zLim, 1)))

'   _______________________________________________________
'   // If VISTA then switch to standard mode
    IF Vista() THEN
       CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)
       CALL CristalDisplay(hMain)
    END IF

'   // Update background to match preferences
    CALL EmulateTransparency(hMain, 0)

END SUB

SUB CristalDisplay(BYVAl hWnd AS LONG)
    LOCAL Alpha, Red, Green, Blue AS BYTE, rc AS RECT
    IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) THEN
       CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
       CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
       CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
       CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
       CALL zAEROEMULATE(%TRUE, %WRITE)
       CALL zAEROBLURLEVEL(0, %WRITE)
       CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

       CALL zUSEVISTABLUR(%FALSE, %WRITE)
       CALL zUSEVISTACRYSTAL(%TRUE, %WRITE)
       '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

    ELSE
       '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
       CALL KillTimer(hWnd, %AERO_TIMER)
       CALL zAEROEMULATE(%FALSE, %WRITE)

       CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

       CALL zUSEVISTABLUR(%FALSE, %WRITE)
       CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
    END IF
    CALL GetWindowRect(hWnd, rc)
    CALL zMoveBackground(rc.nLeft, rc.nTop)

    CALL EmulateTransparency(hWnd, 0) '// 10-20-2007

    CALL zUpdateWindow(hWnd, 0)
END SUB

'// 10-20-2007
SUB EmulateTransparency(BYVAL hWnd AS LONG, BYVAL ShowHide AS LONG)
    LOCAL hIC, hDC, hCtrl, bmW, bmH, xW, yH, hDIB AS LONG, lp AS POINTAPI, rw AS RECT

    IF zGetCheckButtonStatus(zGetMainItem(%ID_BACKGROUND)) THEN
       CALL ZI_SetFromFile(zGetMainItem(%ID_CTRL), zsExePath() + "back.jpg")
    ELSE
       IF Vista() = 0 OR zGetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE)) THEN
          hCtrl = zGetMainItem(%ID_CTRL)
          CALL GetWindowRect(zGetMainItem(%ID_CTRL), rw)
          xW = rw.nRight - rw.nLeft: yH = rw.nBottom - rw.nTop
          CALL ZI_GetBitmapSize(ZI_GetBMP(hCtrl), bmW, bmH)
          hIC = zDisplayDC()
          
'         // Create new background for the GDImage control
          IF xW <> bmW OR yH <> bmH THEN
             CALL ZI_DeleteControlBitmap(hCtrl)
             CALL ShowScrollBar(hCtrl, %SB_BOTH, %FALSE)  ' We don't want any GDImage scrollbar there
             hDC = CreateCompatibleDC(hIC)
             hDIB = zCreateDIBSection(hIC, xW, yH, 32)
             CALL SelectObject(hDC, hDIB)
             CALL ZI_SetProperty(hCtrl, %ZI_Bitmap, hDIB) ' Save DIB
             CALL ZI_SetProperty(hCtrl, %ZI_DC, hDC)      ' Save DC aka ZI_GetDC
          END IF

'         // We draw the zSkin background into the GDImage control background
          hDC = CreateCompatibleDC(hIC)
          CALL SelectObject(hDC, zGetBackBitmap(hWnd))    ' The zSkin bitmap
          lp.x = rw.nLeft: lp.y = rw.nTop
          CALL ScreenToClient(hWnd, lp)
          CALL BitBlt(ZI_GetDC(hCtrl), 0, 0, xW, yH, hDC, lp.x, lp.y, %SRCCOPY)
          CALL DeleteDC(hDC)

          CALL DeleteDC(hIC)
       ELSE
          CALL ZI_SetFromFile(zGetMainItem(%ID_CTRL), zsExePath() + "No_Picture.png")
       END IF
    END IF
    IF ShowHide THEN CALL ZI_UpdateWindow(zGetMainItem(%ID_CTRL), 0)
END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
    LOCAL nRet, wP, hDC, hDCmem AS LONG
    LOCAL Alpha, Red, Green, Blue AS BYTE

    STATIC IsMoving AS LONG

    SELECT CASE LONG Msg
    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         IF gBlinkCount THEN CALL ButtonBlink(%ID_BTN_Play, 1) '// Stop it

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_BTN_PLAY
              CALL PlayCarousel()

         CASE %ID_BTN_PAUSE
              CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_BOTTOM)
              CALL ShowWindow(zGetMainItem(%ID_BTN_PLAY), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_BTN_PLAY), %HWND_TOP)
              gAnimate = 0

         CASE %ID_LEFTBUTTON
              gMoveToLeft = -1
              CALL PlayCarousel()

         CASE %ID_RIGHTBUTTON
              gMoveToLeft = 0
              CALL PlayCarousel()

         CASE %ID_BTN_RESET
            ' Setup Speed default
              CALL zSetTrackValue(zGetMainItem(%ID_TRACK_SPEED), %Speed_default)
            ' Setup Focus default
              CALL zSetTrackValue(zGetMainItem(%ID_TRACK_FOCAL), %Focus_default)
            ' Setup Y default
              CALL zSetTrackValue(zGetMainItem(%ID_TRACK_Y), %Y_default)

         CASE %ID_MARQUEE
              IF zGetCheckButtonStatus(zGetMainItem(%ID_MARQUEE)) THEN
	         CALL ZD_ShowObject(%ID_OBJECT_TEXT, %ZD_SHOW)
              ELSE
	         CALL ZD_ShowObject(%ID_OBJECT_TEXT, %ZD_HIDE)
              END IF

         CASE %ID_BACKGROUND
              CALL EmulateTransparency(hWnd, 1)

         CASE %ID_SELFROTATION
              'UseRotate& = zGetCheckButtonStatus(zGetMainItem(%ID_SELFROTATION))
              'UseRotate& = SendMessage(GetDlgItem(hWnd, %ID_SELFROTATION), %BM_GETCHECK, 0, 0)
              'FOR K& = LBOUND(gSpriteData) TO UBOUND(gSpriteData)
              '    IF UseRotate& = 0 THEN
              '       gSpriteData(K&).hBitmap = ZI_CreateMirrorBitmapFromFile(gSpriteData(K&).ImageName, bmW&, bmH&)
              '    ELSE
              '       gSpriteData(K&).hBitmap = ZI_CreateBitmapFromFile(gSpriteData(K&).ImageName, bmW&, bmH&)
              '    END IF
              '    CALL ZD_DrawBitmapToCtrl(zGetMainItem(%ID_CTRL), gSpriteData(K&).xPos, gSpriteData(K&).yPos, _
              '                             gSpriteData(K&).hBitmap, &HFFFFFFFF, gSpriteData(K&).ID, %ZS_VISIBLE)
              'NEXT

         CASE %ID_AEROCRYSTAL
              CALL CristalDisplay(hWnd)

         CASE %ID_AEROBLUR
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(6, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
                 CALL zUSEVISTABLUR(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop)
              CALL EmulateTransparency(hWnd, 0) '// 10-20-2007
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AERODISABLE
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE)) THEN
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%FALSE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop)
                 CALL EmulateTransparency(hWnd, 0) '// 10-20-2007
                 CALL zUpdateWindow(hWnd, 0)
              ELSE
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)
              END IF

         CASE %ID_TRACK_OPACITY
              IF SK_AEROEMULATE() THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(lParam, RGB(Red, Green, Blue)), %WRITE)
                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop)
                 CALL zUpdateWindow(hWnd, 0)
              END IF
         END SELECT

    CASE %WM_SIZE
         IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
         CALL zDrawBackground()
         CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
         'CALL zUpdateWindow(hWnd, 0)
CALL EmulateTransparency(hWnd, 1)

         IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground()
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG, p AS POINTAPI
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground()

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

'   //START AERO section ---------------------------------------------------------
    CASE %WM_TIMER
         IF wParam = %CAROUSEL_TIMER THEN
            CALL DrawCarousel()
         ELSEIF wParam = %BLINK_TIMER THEN
            CALL ButtonBlink(%ID_BTN_Play, 0)
            FUNCTION = 0: EXIT FUNCTION
         ELSE
            IF zDwmIsCompositionEnabled() = 0 THEN
               IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                  IF zIsLButtonDown() = 0 THEN IsMoving = 0
                  IF IsMoving = 0 OR (zIsLButtonDown() AND IsMoving) THEN
                     CALL GetWindowRect(hWnd, rc)
                     CALL zMoveBackground(rc.nLeft, rc.nTop)
                     CALL zUpdateWindow(hWnd, 0)
                  END IF
               END IF
            END IF
         END IF

    CASE %WM_NCLBUTTONDOWN
         IsMoving = -1

    CASE %WM_MOVING
         IF zDwmIsCompositionEnabled() = 0 THEN
            IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
               DIM rw AS RECT PTR
               rw = lparam
               CALL zMoveBackground(@rw.nLeft,@rw.nTop)
               CALL zUpdateWindow(hWnd, 0)
               FUNCTION = 1: EXIT FUNCTION
            END IF
         END IF
'   //END AERO section ---------------------------------------------------------

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB PlayCarousel()
    CALL ShowWindow(zGetMainItem(%ID_BTN_PLAY), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PLAY), %HWND_BOTTOM)
    CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_TOP)
    IF LBOUND(gSpriteData) < 1 THEN
       CALL LoadSprites()
       gAnimate = -1
    ELSE
       gAnimate = -1
    END IF
END SUB

SUB LoadSprites()

    DIM gSpriteData(1 TO %ID_MAX_SPRITE) AS SpriteDataStruct

    DIM zorder(1 TO %ID_MAX_SPRITE) AS LONG
    DIM faceorder(1 TO %ID_MAX_SPRITE) AS LONG

    gSpriteData(01).ImageName = SK_FOLDER() + "red.png"
    gSpriteData(02).ImageName = SK_FOLDER() + "green1.png"
    gSpriteData(03).ImageName = SK_FOLDER() + "red.png"
    gSpriteData(04).ImageName = SK_FOLDER() + "yellow3.png"
    gSpriteData(05).ImageName = SK_FOLDER() + "green.png"
    gSpriteData(06).ImageName = SK_FOLDER() + "blue1.png"
    gSpriteData(07).ImageName = SK_FOLDER() + "cyan.png"
    gSpriteData(08).ImageName = SK_FOLDER() + "yellow1.png"
    gSpriteData(09).ImageName = SK_FOLDER() + "blue.png"
    gSpriteData(10).ImageName = SK_FOLDER() + "cyan2.png"
    gSpriteData(11).ImageName = SK_FOLDER() + "red1.png"
    gSpriteData(12).ImageName = SK_FOLDER() + "red2.png"
    

    StepAngle& = 360 / (%ID_MAX_SPRITE - 1)
    UseRotate& = zGetCheckButtonStatus(zGetMainItem(%ID_SELFROTATION))

    FOR K& = 1 TO %ID_MAX_SPRITE

        'IF UseRotate& = 0 THEN
        '   gSpriteData(K&).hBitmap = ZI_CreateMirrorBitmapFromFile(gSpriteData(K&).ImageName, bmW&, bmH&)
        'ELSE
           gSpriteData(K&).hBitmap = ZI_CreateBitmapFromFile(gSpriteData(K&).ImageName, bmW&, bmH&)
        'END IF
        gSpriteData(K&).ID      = K&
        gSpriteData(K&).nWidth  = bmW&
        gSpriteData(K&).nHeight = bmH&
        gSpriteData(K&).rAngle  = AngleStep&

        CALL ZD_DrawBitmapToCtrl(zGetMainItem(%ID_CTRL), gSpriteData(K&).xPos, gSpriteData(K&).yPos, _
                                 gSpriteData(K&).hBitmap, &HFFFFFFFF, gSpriteData(K&).ID, %ZS_VISIBLE)

        AngleStep& = AngleStep& + StepAngle&

        CALL ZD_UsePngOpacity(K&, %TRUE)
    NEXT

    LOCAL rc AS RECT
    CALL GetClientRect(zGetMainItem(%ID_CTRL), rc)
    CALL ZD_DrawTextToCtrl(zGetMainItem(%ID_CTRL), _
                           "No DirectX, no OpenGL, no WPF, just plain lean GDImage ...", _
                           rc.nRight, _                           ' X coordinate
                           10, _                                  ' Y coordinate
                           ZD_ColorARGB(229, RGB(69,100,132)), _  ' ARGB color
                           "Times New Roman", _                   ' True Type Font to use
                           40, _                                  ' Font size in pixel
                           %ID_OBJECT_TEXT, _                     ' Unique object ID
                           %ZS_HIDDEN, _                          ' Hidden
                           0, _                                   ' No shadow
                           0)                                     ' Optional string format
    CALL ZD_GetObjectBound(%ID_OBJECT_TEXT, gnBoundWidth, gnBoundHeight)

END SUB

SUB DrawCarousel()

    IF gAnimate THEN
       LOCAL K, x, y AS LONG, rAngle AS SINGLE, rc AS RECT

       DIM zorder(1 TO %ID_MAX_SPRITE) AS LONG
       DIM faceorder(1 TO %ID_MAX_SPRITE) AS LONG

       y&        = zGetTrackValue(zGetMainItem(%ID_TRACK_Y)) ' Default = 50
       speed!    = zGetTrackValue(zGetMainItem(%ID_TRACK_SPEED)) / 4
       fl!       = zGetTrackValue(zGetMainItem(%ID_TRACK_FOCAL)) / 100 ' Default = 150
                   IF fl! < .02 THEN fl! = 0.001
       PiDiv180# = 1.74532925199433E-2#
       CALL GetClientRect(zGetMainItem(%ID_CTRL), rc)
       xcenter&  =(rc.nRight - 128) / 2
       ycenter&  =(rc.nBottom - 128) / 2
       zcenter&  = ycenter& / 2
       radius&   = rc.nRight / 3.675 ' 160

       FOR K = %ID_MAX_SPRITE TO 1 STEP -1
           
           rAngle = gSpriteData(K).rAngle: anglePi! = rAngle * PiDiv180#
           z! = SIN(anglePi!) * radius& + zcenter&
           scale! = fl! / (fl! + z!)
           x& = COS(anglePi!) * radius&
           gSpriteData(K).xPos = x& * scale! + xcenter&
           gSpriteData(K).yPos = y& * scale! + ycenter& - y&

           'xscale!= scale! * 100: yscale! = xscale!

           zorder(K) = rAngle - 90: IF zorder(K) > 180 THEN zorder(K) = 360 - zorder(K)
           faceorder(K) = K

           IF K MOD 2 = 0 THEN 'gMoveToLeft THEN
              rAngle = rAngle - speed!
              IF rAngle < 1 THEN rAngle = 360
           ELSE
              rAngle = rAngle + speed!
              IF rAngle > 359 THEN rAngle = rAngle - 360
           END IF
           gSpriteData(K).rAngle = rAngle

         ' Compute the scale factor
           IF zGetCheckButtonStatus(zGetMainItem(%ID_USE3D)) THEN
              CALL ZD_SetObjectScale(gSpriteData(K).ID, (ABS(zorder(K)) MOD 182) * 0.0027777 + .5)
           ELSE
              CALL ZD_SetObjectScale(gSpriteData(K).ID, 1)
           END IF

         ' Switch the Alpha channel accordingly
           IF zGetCheckButtonStatus(zGetMainItem(%ID_OPACITY)) AND fl! > .999 THEN
              CALL ZD_SetObjectAlpha(gSpriteData(K).ID, MIN&(180 * scale!, 255), %FALSE)
           ELSE
              CALL ZD_SetObjectAlpha(gSpriteData(K).ID, 255, %FALSE)
           END IF

           CALL ZD_SetObjectXY(gSpriteData(K).ID, gSpriteData(K).xPos, gSpriteData(K).yPos, %FALSE)

           IF zGetCheckButtonStatus(zGetMainItem(%ID_SELFROTATION)) THEN
              CALL ZD_SetObjectAngle(gSpriteData(K).ID, CLNG(gSpriteData(K).rAngle), %FALSE)
           ELSE
              CALL ZD_SetObjectAngle(gSpriteData(K).ID, 0, %FALSE)
           END IF

       NEXT

     ' Compute the current Z-order
       ARRAY SORT zorder(), TAGARRAY faceorder()

     ' Set the Sprite's Z-order
       K = faceorder(1)
       IF gMoveToLeft THEN
          K = K + 1: IF K > %ID_MAX_SPRITE THEN K = 1
       END IF

       CALL ZD_SetObjectZorder(gSpriteData(K).ID, %ZD_ORDER_BOTTOM)
       CALL ZD_SetObjectZorder(gSpriteData(faceorder(%ID_MAX_SPRITE)).ID, %ZD_ORDER_TOP)

       IF zGetCheckButtonStatus(zGetMainItem(%ID_MARQUEE)) THEN CALL DrawMarquee(rc.nRight)

     ' Update the control display
       CALL ZI_UpdateWindow(zGetMainItem(%ID_CTRL), 0)

    END IF
END SUB

SUB DrawMarquee(BYVAL nRight AS LONG)
    LOCAL x, y AS LONG
    CALL ZD_GetObjectXY(%ID_OBJECT_TEXT, x, y)
    x = x - 2
    IF x < - gnBoundWidth THEN x = nRight
    CALL ZD_SetObjectXY(%ID_OBJECT_TEXT, x, y, %ZD_DRAW_DEFERRED)
END SUB

SUB ButtonBlink(BYVAL ID AS LONG, BYVAL nStop AS LONG)
    LOCAL hBut, Img, ImgW, ImgH, ButtonStyle, hDC, graphics, UseTimer AS LONG
    LOCAL rc, rw AS RECT
    LOCAL lp AS POINTAPI
    STATIC UseState AS LONG
    INCR gBlinkCount
    hBut = zGetMainItem(ID) ' // %ID_BTN_Select
    Img = zGetButImageProperty(hBut)
    CALL GetWindowRect(hBut, rw)
    lp.x = rw.nLeft: lp.y = rw.nTop
    CALL ScreenToClient(zMainwindow(0), lp)
    IF UseState < 5 THEN UseState = 5 ELSE UseState = 1
    IF nStop THEN UseState = 1
    hDC = GetDC(zMainwindow(0))

    CALL SetRect(rc, lp.x, lp.y, lp.x + rw.nRight - rw.nLeft, lp.y + rw.nBottom - rw.nTop)
    CALL InvalidateRect(zMainwindow(0), rc, %TRUE)
    CALL UpdateWindow(zMainwindow(0))

    IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
       CALL zPaintButton(graphics, UseState, Img, lp.X, lp.Y, rw.nRight - rw.nLeft, rw.nBottom - rw.nTop, %BS_PUSHBUTTON)'ButtonStyle)
       CALL GdipDeleteGraphics(graphics)
    END IF
    CALL ReleaseDC(zMainwindow(0), hDC)
    'IF ID = %ID_BTN_User THEN
    '   UseTimer = %BLINK_USER: gBlinkCount = 1
    'ELSE
       UseTimer = %BLINK_TIMER
    'END IF
    IF gBlinkCount > 29 OR nStop THEN
       gBlinkCount = 0: CALL KillTimer(zMainWindow(0), UseTimer)
       CALL InvalidateRect(zMainwindow(0), rc, %TRUE)
       CALL UpdateWindow(zMainwindow(0))
    END IF
END SUB
